# -*- coding: utf-8 -*-


import libvisioo.oofichier as oofichier
import libvisioo.ooloader as ooloader
import libvisioo.ooparser as ooparser

from libvisioo.GLOBALS import TEMP_EXTRACT_DIR, sep

class Content :
	def __init__ (self, fichier, ui_name) :
		self.ui = ooloader.load_ui(ui_name)
		oofichier.efface_rep_tmp()
		self.EXTRACT_OK = False

		self.fichier = fichier
		self.notes = self.ui.ZoneTexte('notes')
		self.main = self.ui.ZoneTexte('main')

		self.LIST_OOO_1x = ("sxw", "sxc", "sxi", "sxd")
		self.LIST_OOO_2x = ("odt", "odg")
		self.LIST_OOO = self.LIST_OOO_1x+self.LIST_OOO_2x

		self.ext = oofichier.extension(self.fichier)

		if self.ext in self.LIST_OOO :
			self.__extraction()

			if self.ext in self.LIST_OOO_1x :
				handler = ooloader.load_handler("ooo1")

			elif self.ext in self.LIST_OOO_2x :
				handler = ooloader.load_handler("ooo2")

			self.styles = handler.Styles(ui_name)
			self.content = handler.Content(ui_name)
			self.content.set_verbose(False)

			if self.EXTRACT_OK : self.__set_content()
			else : self.__display_text ()

		else : self.__display_text ()

	def __display_text (self):
		handler = ooloader.load_handler("txt")
		fi = open(self.fichier, "r")
		ls = fi.readlines()
		for l in ls : self.main.texte(l)
		fi.close()

	def __extraction (self):
		try : oofichier.extraction(self.fichier)
		except :
			self.ui.Bug(_("Error when extracting : %s No valid"\
			%oofichier.extension(self.fichier)))
			self.EXTRACT_OK = False
		else : self.EXTRACT_OK = True

	def __set_content (self):
		ooparser.parseur(TEMP_EXTRACT_DIR+sep+"styles.xml", self.styles)

		# Ajout des données de style
		self.content.dico_styles.update(self.styles.dico_styles)
		self.content.HEADER_CONTENT = self.styles.HEADER_CONTENT
		self.content.FOOTER_CONTENT = self.styles.FOOTER_CONTENT

		# traitement de content.xml (decl styles et objets + corps du texte)
		ooparser.parseur(TEMP_EXTRACT_DIR+sep+"content.xml", self.content)

		self.main = self.content.main
		self.main.config ((10,10))
		self.main.bordure (5,20,5,20)

		self.notes = self.content.NOTE_CONTENT
		self.notes.config ((20,10))
		self.notes.bordure (5,20,5,20)


	def get_content (self): return self.main
	def get_notes (self): return self.notes
