# -*- coding: utf-8 -*-

__author__ = "Guillaume BATY"
__version__ = "0.1"
__copyright__ = "Copyright (c) 2004 Guillaume BATY"
__license__ = "GPL"
__description__ = "Traitement basique des fichiers (extraction, supression rep tmp...)"

import zipfile
import sys, os, shutil

# def _ (s) : return s

from os.path import getsize, exists, normpath
from libvisioo.GLOBALS import *
from libvisioo.debug import *

def unit2px (size, unit) :
	""" convert tuple (size, unit) ex ("20", "pt") to px """
	if unit in ("px", "pixels", "pt") : return size
	elif unit in ("cm", "centimeters", "centimetres") : return size*40
	elif unit in ("inch", "pouces") : return size*15

def supr (val0, nb = 1) :
	"""renvoie la chaine val sans les nb derniers caractères
	return val string without last nb characters
	ex : supr('20pt',2) -> ('20','pt') """
	unit = "NO UNIT"
	valf = 0
	if val0 :
		if val0 >= nb : val = val0[0:-nb]
		try : valf = float(val)
		except :
			i = 0
			valf = ""
			while val[i] in list("0123456789.") :
				valf+=val[i]
				i+=1
			valf = float(valf)
			unit = val0[i:]
		else : unit = val0[-nb:]

	return valf, unit

def oo2px (oosize):
	""" convert OpenOffice size to (size, unit) tuple
	ex : '20pt' -> (20, 'pt')
	"""
	size, unit = supr(oosize)
	return unit2px (size, unit)

def taille_fichier(file):
	""" renvoie une chaine de car avec la taille en o, ko ou mo suivie de l'unité"""
	t = getsize(file)
	if t<1024:
		t = str(t)+' ' + _("bytes")
	elif t < 1048576:
		t = str(t/1024.)[0:5]+' K' + _("bytes")
	else:
		t = str(t/1048576.)[0:5]+' M' + _("bytes")
	return t

def extension (file):
	"""lecture de droite à gauche
	càd ext = tout ce qui est après le dernier point"""
	car = ''
	i = len(file)-1
	while car != '.' and i >= 0:
		car = file[i]
		i -= 1
	return file[i+2:].lower()

def file_name ():
	return import_fichier().split(os.sep)[-1].split('.')[0]

def copy_picture ():
	shutil.copytree (os.sep.join([TEMP_EXTRACT_DIR, 'Pictures']), 'Pictures')

def import_fichier ():
	"""retourne le nom de fichier en paramètre, DEFAULT si aucun"""
	opt = sys.argv[1:]
	path = " ".join(opt)

	if path:
		return normpath(path)
	else:
		return SHARE_PATH + sep + DEFAULT_OOO_FILE


def extraction (file):
	"""extrait file"""

# 	print lg(2,3,'debug')%file
	fzip = zipfile.ZipFile(file, mode = "r", compression = zipfile.ZIP_STORED)
# 	fzip.printdir()
	oldrep = os.getcwd()
	if not exists(TEMP_EXTRACT_DIR):
		os.mkdir(TEMP_EXTRACT_DIR)
	else : pass

	os.chdir(TEMP_EXTRACT_DIR)
	rep_extract_abs = os.getcwd()

	list_zip_files = fzip.namelist()

	for fichier in list_zip_files :
		reps = fichier.split("/")
		i = 0
		while i<len(reps)-1:
			if not exists(reps[i]) : os.mkdir(reps[i])
			os.chdir(reps[i])
			i+=1
		os.chdir(rep_extract_abs)

	for fichier in list_zip_files :
		if fichier != "" and not exists(fichier) : extr_fichier (fzip, fichier)

	fzip.close()
# 	os.chdir(os.pardir)
	os.chdir(oldrep)

def extr_fichier (fzip, file):
	f = open (file,'w')
	ligne = fzip.read(file)
	f.write(ligne)
	f.close()

def efface_rep_tmp (path = TEMP_EXTRACT_DIR):
	if os.path.exists(path) : shutil.rmtree(path)



