# -*- coding: utf-8 -*-

import libvisioo.ooparser as ooparser
import libvisioo.oofichier as oofichier
import libvisioo.ooloader as ooloader

import xml.sax, os
from libvisioo.debug import *

from GLOBALS import sep, TEMP_EXTRACT_DIR, PICS_PATH


class MathHandler (xml.sax.ContentHandler):
	def __init__(self) :
		self.MATH_ENCODING=1
		self.FORMULE=""

	def startDocument (self) : pass
	def endDocument (self) : pass

	def characters (self, content) :
		if self.MATH_ENCODING : self.FORMULE=content

	def startElement (self, name, attrs) :
		if name=="math:annotationmath:encoding" : self.MATH_ENCODING=1

	def endElement (self, name) : pass


class MathObject (MathHandler) :
	""" très loin d'être fini """
	def __init__ (self, abspath, ui_name) :
		MathHandler.__init__(self)
		ooparser.parseur(abspath, self)
		self.ui=ooloader.load_ui(ui_name)

	def return_object (self):

		obj=self.ui.ZoneTexte()
		obj.def_wrap_mode("WRAP_NONE")
		obj.texte(" ")

		expr=self.FORMULE

		expr=expr.split()

		for elem in expr :
			if elem in DICO_TXT_MATH.keys() : obj.texte(DICO_TXT_MATH[elem])
			elif elem in PICS_MATH :
				img="%s%smath%s%s" %(PICS_PATH, sep, sep,elem)
				obj.image_abs(img)
			else :
				obj.texte(elem)
				todo("MATH", elem, aff=False)

		obj.texte(" ")
		return obj

class Object :
	def __init__ (self, href, ui_name):
		href=TEMP_EXTRACT_DIR+sep+href[3:]
		abspath=href+sep+"content.xml"
		if 1 : object=MathObject(abspath, ui_name)

		self.OBJECT=object.return_object()

PICS_MATH = [
"dlrarrow",
]

DICO_TXT_MATH = {
#Operators
"over":"/",
"toward":"->",
"<>":"≠",
"&":"",

"infinity":"∞",
"cdot":".",



"%alpha" : "α",
"%beta" : "β",
"%gamma" : "γ",
"%delta" : "δ",
"%epsilon" : "ε",
"%zeta" : "ζ",
"%eta" : "η",
"%theta" : "θ",
"%iota" : "ι",
"%kappa" : "κ",
"%lambda" : "λ",
"%mu" : "μ",
"%nu" : "ν",
"%xi" : "ξ",
"%pi" : "π",
"%rho" : "ρ",
"%sigma" : "σ",
"%tau" : "τ",
"%upsilon" : "υ",
"%phi" : "φ",
"%chi" : "χ",
"%psi" : "ψ",
"%omega" : "ω",
"%ALPHA" : "A",
"%BETA" : "B",
"%GAMMA" : "Γ",
"%DELTA" : "Δ",
"%EPSILON" : "Ε",
"%ZETA" : "Ζ",
"%ETA" : "Η",
"%THETA" : "Θ",
"%IOTA" : "Ι",
"%KAPPA" : "Κ",
"%LAMBDA" : "Λ",
"%MU" : "Μ",
"%NU" : "Ν",
"%XI" : "Ξ",
"%PI" : "Π",
"%RHO" : "Ρ",
"%SIGMA" : "Σ",
"%TAU" : "Τ",
"%UPSILON" : "Υ",
"%PHI" : "Φ",
"%CHI" : "Χ",
"%PSI" : "Ψ",
"%OMEGA" : "Ω",

"left":"",
"right":"",

"lbrac":"{",
"rbrac":"}",
"emptyset":"O"

#Caracters
}
