# -*- coding: utf-8 -*-

import xml.sax
import string

import libvisioo.ooparser as ooparser
import libvisioo.oofichier as oofichier
import libvisioo.ooloader as ooloader
import libvisioo.oostyles as oostyles


from libvisioo.GLOBALS import TEMP_EXTRACT_DIR, sep

def ooo_parse_generator (var_string) :
	output = ""
	for c in var_string :
		if c != "$" : output += c
		else : break

	return output

class OOOMetaHandler (xml.sax.ContentHandler):
	def __init__(self):
		self.liste_data=[]

	def startDocument (self):
		self.liste_data=[]

	def endDocument (self):
		pass

	def characters (self, content):
		if self.balise == "meta:generator" : content = ooo_parse_generator(content)
		self.liste_data.append ((self.balise, string.strip(content)))

	def startElement(self, name, attrs):
		self.balise=name
		if name == 'meta:document-statistic':
			self.stat=attrs.items()

class OOOMeta :
	def __init__ (self, fichier, ui_name) :
		self.ui=ooloader.load_ui(ui_name)

		self.fichier=fichier

		self.LIST_OOO_1x=("sxw", "sxc", "sxi", "sxd")
		self.LIST_OOO_2x=("odt", "odg")
		self.LIST_OOO=self.LIST_OOO_1x+self.LIST_OOO_2x

		self.ext=oofichier.extension(self.fichier)

		self.main=self.ui.ZoneTexte()
		self.main.config ((30,30), 10)
		self.main.bordure (5,20,5,20)
		self.liste_balise = 'meta:generator dc:creator dc:language dc:title meta:creation-date dc:subject dc:date meta:keywords meta:user-defined'.split()
		self.liste_stat='meta:word-count meta:image-count meta:object-count meta:page-count meta:character-count meta:paragraph-count meta:table-count'.split()
		self.liste=self.liste_balise+self.liste_stat

		self.dico={}
# 		self.FILE=file

		meta_strings = [
			_("generator"),
			_("author(s)"),
			_("language"),
			_("title"),
			_("creation date"),
			_("subject"),
			_("date"),
			_("keywords"),
			_("info"),
			_("number of words"),
			_("number of pictures"),
			_("number d'objects"),
			_("number of pages"),
			_("number of caracters"),
			_("number of paragraphs"),
			_("number of table")]

		for i in range(len(self.liste)):
			self.dico.update({self.liste[i]: meta_strings[i]})

		self.metahandler=OOOMetaHandler()


		self.titre = oostyles.OOStyle("Titre")
		self.titre.add_prop(('fo:color','#000099'))
		self.titre.add_prop(('fo:font-size','16pt'))
		self.titre.add_prop(('fo:text-align','center'))

		self.style_metakeys = oostyles.OOStyle("MetaKeys")
		self.style_metakeys.add_prop(('fo:font-style','italic'))
		self.style_metakeys.add_prop(('fo:font-weight','bold'))
		self.style_metakeys.add_prop(('fo:color','#0000FF'))

		self.style_metavalues = oostyles.OOStyle("MetaValues")
		self.style_metavalues.add_prop(('fo:font-weight','bold'))

	def format_data(self):
		""" affiche les noms et les valeurs des éléments data
		display names and values of data elements"""
		ooparser.parseur(TEMP_EXTRACT_DIR+sep+"meta.xml", self.metahandler)
		return self.metahandler.liste_data, self.metahandler.stat

	def get_meta (self) :
		liste=[]

		value=self.format_data()
		liste=value[0]+value[1]

		self.main.texte_oo( _("Meta-Info"), self.titre)
		self.main.texte('\n\n')

		for elem in liste:
			if elem[0]=='meta:word-count' : self.main.texte('\n')
			if elem[0] in self.liste :
				self.main.texte_oo(self.dico[elem[0]]+'  :  ', self.style_metakeys)
				self.main.texte_oo(elem[1]+'\n', self.style_metavalues)

		return self.main

