#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = "Guillaume BATY"
__version__ = "0.1"
__copyright__ = "Copyright (c) 2004 Guillaume BATY"
__license__ = "GPL"
__description__="Interface graphique de visioo-writer"

import gtk
import os, os.path
from libvisioo.GLOBALS import LANGUAGE_PATH, PICS_PATH, CONFIG_PATH

os.chdir(LANGUAGE_PATH)
ls=os.listdir(os.curdir)
liste=[
"astuces",
"debug",
"main",
"meta",
"thanks",
]

class LanguageWindow :
	"""fenetre principale"""
	def __init__ (self, *args):
		self.final=None
# 		self.list_file=[]

		self.win=gtk.Window()
		self.win.set_title("Changer la Langue - Change Language")
		self.win.set_icon(gtk.gdk.pixbuf_new_from_file(PICS_PATH+os.sep+"language.png"))
		self.win.connect('destroy', self.kill)
		self.win.set_resizable(gtk.TRUE)
		self.win.resize(150, 10)

		self.bv=gtk.VBox()

		self.ok=gtk.Button("OK")
		self.ok.connect("clicked", self.ok_clicked)
		self.bv.pack_end(self.ok)

		self.widget=gtk.RadioButton(None, "No Change")
		self.widget.connect('toggled',self.change)
		self.bv.pack_start(self.widget)


		for elem in ls :
			widget=gtk.RadioButton(self.widget, elem)
			widget.connect('toggled',self.change)
			self.bv.pack_start(widget)


		self.win.add(self.bv)
		self.win.show_all()

	def change (self, widget):
		self.final=widget.get_label()


	def ok_clicked (self, *args):
		""" compare les fichiers par défaut et les fichiers de la langue choisie
		change tout ce qui a été traduit et renvoie en console ce qui reste à faire """
		if self.final and self.final!= "No Change":
			print self.final
			for file in liste :
				old=open(CONFIG_PATH+os.sep+file, "r")
				try : new=open(LANGUAGE_PATH+os.sep+self.final+os.sep+file, "r")
				except : print "file", file, "not found"
				else :
					oldl=old.readlines()
					newl=new.readlines()
					final=[]
					i=0
					while i < len(newl) :
						final.append(newl[i])
						i+=1

					while i<len(oldl):
						print "todo in file", file, ":", oldl[i], "line", i+1
						final.append(oldl[i])
						i+=1

					sortie=open(CONFIG_PATH+os.sep+file, "w")
					for l in final : sortie.write(l)



		self.kill()

	def kill (self, *args):
		self.win.destroy()
		gtk.main_quit()



if __name__ == '__main__':
	LanguageWindow()
	gtk.main()
